<?php
class XMLIncomingCalls {

    var $addr;
    var $port;
    var $user_name;
    var $password;
    var $sock;
    var $arrTransferIDs;
    var $arrSubscrExtension;
	var $gl_filepath;

    function XMLIncomingCalls ( $sock, $addr, $port , $user_name, $password, $filepath )
	{
		$this->sock = $sock;
		$this->addr = $addr;
		$this->port = $port;
		$this->user_name = $user_name;
		$this->password = $password;
		$this->gl_filepath = $filepath;
		$this->arrTransferIDs = array();
		$this->arrSubscrExtension = array();
    }
	
    function Authenticate()
	{
		$arr = array($this->user_name, $this->password);
		$method = "Services.CallProcessingService.authenticate";	
		$request = xmlrpc_encode_request($method,$arr);	
		$request = $request."\r\n\r\n";		
		
		if( !socket_write($this->sock, $request, strlen($request)) ) {
			echo "Authenticate() Socket error.Cannot send.(function: socket_write)";
			eixt(0);
		}

		// get a list of all the clients that have data to be read from
		// if there are no clients with data, go to next iteration
		$var = array($this->sock);
		$write = NULL;
		$except = NULL;
		
		if( !socket_select($var, $write, $except, array("sec" => 10, "usec" => 0)) ) {
		    echo "socket_select() failed, reason: " .
       		socket_strerror(socket_last_error()) . "\n";
	   	}
		
		$response = socket_read($this->sock, 4096);
					
		// check if the client is disconnected
		if ($response === false) {
			$go = false;
			unset($this->sock);
			echo "<br>Connection was closed by remote host!";	
			exit(0);		
		}	
	
		$method = "Services.CallProcessingService.authenticate";
		
		$arr = array();
		$arr = xmlrpc_decode_request(trim($response),$method);		
		
		if(strstr($response,"<methodResponse>") && $arr == "Wrong username or password.") {
			return false; 
		} else {
			return true; 
		}
	}

	// subscribe for incoming calls
	function IncomingCallHandling($extName, $enable)
	{
		if(empty($extName)) {
			echo "Parameter 'extName' is empty !";
		}	
		
		$arr = array($extName, $enable);
		$method = "Services.CallProcessingService.incomingcallhandling";	
		$request = xmlrpc_encode_request($method,$arr);	
		$request = $request."\r\n\r\n";

		echo $request;		
		
		if( !socket_write($this->sock, $request, strlen($request)) ) {
			echo "IncomingCallHandling: Socket error.Cannot send.(function: socket_write)";
			//eixt(0);
		}
	}
	
	function ParseIncomingCall($filepath,$output,$db_host,$db_username,$db_password,&$arrSubscriptions,&$call_count)
	{
		if(empty($output)) {
			echo "ParseIncomingCall: Parameter 'output' is empty !";
			//exit(0);
		}

		$method = "Services.CallProcessingService.process";
		$method_2 = "Services.CallProcessingService.callstatechanged";
		
		$arrXMLs = array();
		while( strpos($output,"\r\n\r\n") ) {
		
			$pos = strpos($output,"\r\n\r\n");
			array_push($arrXMLs, substr($output,0,$pos));
			$output = substr($output,$pos+4,strlen($output));
		}

		foreach($arrXMLs as $key => $value) {
		
			$output = $value;
			if( strstr($output,"methodResponse" ) != FALSE ) {
				continue;
			} elseif( strstr($output,"Services.CallProcessingService.callstatechanged" ) != FALSE ) {
				
				$arrStCh = xmlrpc_decode_request(trim($value),$method_2);
				$callid = $arrStCh[0];
				$call_status = $arrStCh[1];
				
				$xmlresp = 
				"<?xml version='1.0'?>\n".
				"<methodResponse>\n".	
				"<params>\n".
				"<param>\n".
				"<value><string>".$callid."</string></value>\n".
				"</param>\n".
				"</params>\n".
				"</methodResponse>";

				echo $response = $xmlresp."\r\n\r\n";
				if( !socket_write($this->sock, $response, strlen($response)) )
				{
					echo "ParseIncomingCall(1): Socket error.Cannot send.(function: socket_write)";
				}
				
				$is_outgoing = false;
				
				if( $this->MultiArraySearch($callid, $this->arrSubscrExtension) != false ) {
				
					$ext = $this->arrSubscrExtension[$callid];
					$msg = "";
					if( $call_status == 0 ) {
						$msg = "Trying to connect...";	
					} elseif($call_status == 1 ) {
						$msg = "Ringing...";
					} elseif($call_status == 3 ) {
						$msg = "Call closed.";
						unset($this->arrSubscrExtension[$callid]); 				
					} elseif($call_status == 6 ) {
						$msg = "Call failed.";
						unset($this->arrSubscrExtension[$callid]);						 				
					}
					
					if($call_status != 2 ) {
						echo "INFO: callstatechanged: ".$msg."\n";
					}
	
					// Write to file out_calls/ext.txt call result
					$filename = $filepath."/out_calls/".$ext.".txt";
					if (!$handle = fopen($filename, 'w')) {
						echo "Cannot open file ($filename)";
					} else {
						$content = $msg;
						if (fwrite($handle, $content) === FALSE) {
							echo "Cannot write to file ($filename)";
							exit(0);
						}
						//echo "Success, wrote ($content) to file ($filename)";
	
						fclose($handle);
					}
					
					$is_outgoing = true;
				} 				
				
				// check is it transfer call state changed or not
				if( $this->MultiArraySearch($callid, $this->arrTransferIDs) != false ) {
				
					if( $call_status == 2 ) {
						echo "INFO: callstatechanged: Confirmed.\n";
						
						// find and get transfer number
						$transfer_to = $this->arrTransferIDs[$callid];
						
						if( !empty($transfer_to) ) {							
							$this->TransferCall($callid,$transfer_to);						
							unset($this->arrTransferIDs[$callid]);
							
							$to = $this->arrSubscrExtension[$callid];
							$key = array_search($to,$arrSubscriptions);
							unset($arrSubscriptions[$key]);				
							//unset($this->arrSubscrExtension[$callid]);
						} 				
					}
					
					$is_outgoing = true;
				}
				
				if( ( $call_status == 3 || $call_status == 6) && 
											$call_count > 0 && $is_outgoing == false ) {
					$filename = $callid.".txt";
					$this->CleanupFiles($filepath,$filename);	
					//echo "call_count=".$call_count."\n";	
					echo "Cleanup incoming for this id.\n";	
					$call_count--;				
				}						
			} elseif( strstr($output,"Services.CallProcessingService.process" ) != FALSE ) {
		
				$from = NULL;	
				$to = NULL;
				$ext = NULL;
				$contact = NULL;
				$callid = NULL;
			
				echo "Date: ".date("F j, Y, g:i a")."\n";
	
				// begin ***
				// remove it when will be changed this string content in 3pcc
				$output = str_replace("&lt", " ", $output);
				$output = str_replace("&gt", " ", $output);
				$output = str_replace(";", " ", $output);
				//$output = str_replace("></string>", "</string>", $output);
				// end
				
				$array = xmlrpc_decode_request(trim($output),$method);
				
				foreach($array as $key => $value) {
		
					//echo "key=".$key;
					//echo "value=".$value;
		
					if(is_array($value))
					{
						foreach($value as $key2 => $value2) {
							//echo "key=".$key2;
							//echo "value=".$value2;
							if($key2 == "From") {
								$from = $value2;
							}
							if($key2 == "To") {
								$to = $value2;
							}
							if($key2 == "Ext") {
								$ext = $value2;
							}
						}
					}
				}
				
				$callid = $array[1];
				
				echo "Call ID:".$callid."\n";
				echo "Call from:".$from."\n";
				echo "Call to:".$to."\n";
				echo "Call to extension:".$ext."\n";
				
				// Let's make sure the file exists and is writable first.
				$filename = $filepath."/callids.txt";
				$filename2 = $filepath."/callids2.txt";
				$filename3 = $filepath."/callids3.txt";

				if ( filesize($filename) == 0 ) {
					$this->WriteToFile($filename,$callid);
				} elseif( filesize($filename2) == 0 ) {
					$this->WriteToFile($filename2,$callid);
				} elseif( filesize($filename3) == 0 ) {
					$this->WriteToFile($filename3,$callid);
				} else {
					// skip for now
					continue;
				}
		
				// Write to file "From" field content
				$filename = $filepath."/calls/".$callid.".txt";
				if (!$handle = fopen($filename, 'w')) {
					 echo "Cannot open file ($filename)";
					 exit(0);
				}
		
				$from_pure = $from; 
		
				if( strstr($from_pure, "\"") != FALSE ) {
					$pos = strpos($from_pure, "\"", 1);
					$from_pure = substr($from_pure, $pos+1, strlen($from_pure));
					// here get content without display name
				}
		
				$strCallerData = $this->GetCallerInfo($db_host,$db_username,$db_password,$from_pure);
		
				$content = "";
				if(!empty($strCallerData)) {
					$content = $from_pure;
				} else {
					if( strstr($from, "\"") != FALSE ) {
						$from = str_replace("\"", " ", $from);
					}
					$content = $from; // with display name
				}
		
				echo "Display content=".$content."\n";
		
				if(!empty($strCallerData)) {
					$content = '<div style="padding-left:3px;margin:2px 0;">
									<span style="font-weight:bold;margin-right:5px;">From:</span><span>'.$content.'</span>
								</div>'.$strCallerData.'*'.$ext;
				} else {
					$content = $content."<br>Not registered in the SugarCRM*".$ext;
				}
		
				if (fwrite($handle, $content) === FALSE) {
					echo "Cannot write to file ($filename)";
					exit(0);
				}
				//echo "Success, wrote ($content) to file ($filename)";
		
				fclose($handle);
				
				$call_count++;
			}
		}
	}	

	function WriteToFile($pathtofile,$content)
	{
		if (is_writable($pathtofile)) {		
			if (!$handle = fopen($pathtofile, 'w')) {
			 	echo "Cannot open file ($pathtofile)";
			 	exit(0);
			}
			if (fwrite($handle, $content) === FALSE) {
				echo "Cannot write to file ($pathtofile)";
				exit(0);
			}
			fclose($handle);
		} else {
			echo "The file $pathtofile is not writable";
		}
	}
	
	function GetCallerInfo($host, $username, $password, $from)
	{
		require(dirname(__FILE__) . "/../../config.php");
		$db_name = $sugar_config['dbconfig']['db_name'];
		$db_link = mysql_connect($host, $username, $password, $db_name);
		if( !$db_link ) {
			echo "Connect failed: ".mysql_error();
			exit();
		}
		$db_selected = mysql_select_db($db_name,$db_link);
		if (!$db_selected) {
			die ('Can\'t use foo : ' . mysql_error());
		}
		
		$from = preg_replace('/([a-zA-Z]{3}:)|(pstn:)|(".*")|(@.*)|( )/','',$from);
		
		$sql = "select first_name, last_name, title, department, accounts.name from contacts
				INNER JOIN accounts_contacts on accounts_contacts.contact_id = contacts.id
				INNER JOIN accounts on accounts_contacts.account_id = accounts.id
				where phone_home='".$from."' or phone_mobile='".$from."' or phone_work='".$from."' or phone_other='".$from."' or contacts.phone_fax='".$from."'";
		
		$printSQL = 0;
		if( $printSQL ) { echo $sql."\n";}
		$result=mysql_query($sql) or die ("DB error:".mysql_error($db_link)."\n");
		
		$rowcount = mysql_num_rows($result);
		
		if( $rowcount ) 
		{
			$row = mysql_fetch_row($result);
			mysql_close($db_link);
			return '<div style="padding-left:3px;margin:2px 0;">
						<span style="font-weight:bold;margin-right:5px;">Name:</span><span>'.$row[0].' '.$row[1].'</span>
					</div>
					<div style="padding-left:3px;margin:2px 0;">
						<span style="font-weight:bold;margin-right:5px;">Title:</span><span>'.$row[2].'</span>
					</div>
					<div style="padding-left:3px;margin:2px 0;">
						<span style="font-weight:bold;margin-right:5px;">Account Name:</span><span>'.$row[4].'</span>
					</div>
					<div style="padding-left:3px;margin:2px 0;">
						<span style="font-weight:bold;margin-right:5px;">Department:</span><span>'.$row[3].'</span>
					</div>
					';
		} 
		else 
		{
			$sql = "select first_name, last_name, title, department from contacts
				where phone_home='".$from."' or phone_mobile='".$from."' or phone_work='".$from."' or phone_other='".$from."' or contacts.phone_fax='".$from."'";
		
			$printSQL = 0;
			if( $printSQL ) { echo $sql."\n";}
			$result=mysql_query($sql) or die ("DB error:".mysql_error($db_link)."\n");
			
			$rowcount = mysql_num_rows($result);
			
			if( $rowcount )
			{
				$row = mysql_fetch_row($result);
				mysql_close($db_link);
				return '<div style="padding-left:3px;margin:2px 0;">
							<span style="font-weight:bold;margin-right:5px;">Name:</span><span>'.$row[0].' '.$row[1].'</span>
						</div>
						<div style="padding-left:3px;margin:2px 0;">
							<span style="font-weight:bold;margin-right:5px;">Title:</span><span>'.$row[2].'</span>
						</div>
						<div style="padding-left:3px;margin:2px 0;">
							<span style="font-weight:bold;margin-right:5px;">Department:</span><span>'.$row[3].'</span>
						</div>
						';
			}
			else 
			{
				$sql = "select first_name, last_name, title, department from users where ".
						"phone_home='".$from."' or phone_mobile='".$from."' or phone_work='".$from."' or phone_other='".$from."' or phone_fax='".$from."' or quadro_extension='".$from."'";
				
				if( $printSQL ) { echo $sql."\n";}
				$result=mysql_query($sql) or die ("DB error:".mysql_error($db_link)."\n");
				
				$rowcount = mysql_num_rows($result);
				
				if( $rowcount ) {
					$row = mysql_fetch_row($result);
					mysql_close($db_link);
					return '<div style="padding-left:3px;margin:2px 0;">
								<span style="font-weight:bold;margin-right:5px;">Name:</span><span>'.$row[0].' '.$row[1].'</span>
							</div>
							<div style="padding-left:3px;margin:2px 0;">
								<span style="font-weight:bold;margin-right:5px;">Title:</span><span>'.$row[2].'</span>
							</div>
							<div style="padding-left:3px;margin:2px 0;">
								<span style="font-weight:bold;margin-right:5px;">Department:</span><span>'.$row[3].'</span>
							</div>
							';
				} else {	
				
					$sql = "select name from accounts where phone_office='".$from."' or phone_alternate='".$from."' or phone_fax='".$from."'";
					
					if( $printSQL ) { echo $sql."\n";}
					$result=mysql_query($sql) or die ("DB error:".mysql_error($db_link)."\n");
					
					$rowcount = mysql_num_rows($result);
					
					if( $rowcount ) {
						$row = mysql_fetch_row($result);
						mysql_close($db_link);
						return '<div style="padding-left:3px;margin:2px 0;">
									<span style="font-weight:bold;margin-right:5px;">Account Name:</span><span>'.$row[0].'</span>
								</div>';
					} else {

						$sql = "select first_name, last_name, title from leads where ".
						"phone_home='".$from."' or phone_mobile='".$from."' or phone_work='".$from."' or phone_other='".$from."' or phone_fax='".$from."'";
			
						if( $printSQL ) { echo $sql."\n";}
						$result=mysql_query($sql) or die ("DB error:".mysql_error($db_link)."\n");
			
						$rowcount = mysql_num_rows($result);
			
						if( $rowcount ) {
							$row = mysql_fetch_row($result);
							mysql_close($db_link);
							return '<div style="padding-left:3px;margin:2px 0;">
										<span style="font-weight:bold;margin-right:5px;">Name:</span><span>'.$row[0].' '.$row[1].'</span>
									</div>
									<div style="padding-left:3px;margin:2px 0;">
										<span style="font-weight:bold;margin-right:5px;">Title:</span><span>'.$row[2].'</span>
									</div>
									';
						} else {
							mysql_close($db_link);
							return false;
						}
					}
				}
			}
		}
	}
	
	function SendCallResponse($filepath,$filename)
	{
		$file = $filepath."/calls/".$filename;
		//echo "SendCallResponse: ".$file."\n";
		$handle = fopen($file, "r"); // $filename: 32412341234123412.txt
		if ( filesize($file) == 0 ) {
			return false;
		}	
		$content = fread($handle, filesize($file));
		fclose($handle);
		
		if( strlen($content) == 1 ) {
			$this->SendResponse($filepath, $filename, $content);		
			return true;
		} else {
			return false;
		}		
	}
	
	function SendResponse($filepath, $filename,$content)
	{	
		// parse filename: 26887766583644276.txt
		$callid = substr($filename,0,strlen($filename)-4);
		$action = "";
		if($content == "1") {
			$action = "accept";
		} elseif($content == "0") {
			$action = "decline";
		} else {
			return false;
		}
		
		$request = "<?xml version='1.0'?>\n".
				"<methodResponse>\n".
				"<params>\n".
				"<param>\n".
				"<value><struct>\n".
				"<member>\n".
				"<name>action</name>\n".
				"<value><string>".$action."</string></value>\n".
				"</member>\n".
				"<member>\n".
				"<name>remotecontrol</name>\n".
				"<value><boolean>0</boolean></value>\n".
				"</member>\n".
				"</struct></value>\n".
				"</param>\n".
				"<param>\n".
				"<value><string>".$callid."</string></value>\n".
				"</param>\n".
				"</params>\n".
				"</methodResponse>"; 

		echo $request = $request."\r\n\r\n";		
		
		//$struct_arr = array("action"=>$action, "remotecontrol"=>false);
		//$arcallid = array();
		//$arcallid[0] = $struct_arr;
		//$arcallid[1] = $callid;
		//$method = null;	
		//$request = xmlrpc_encode_request($method,$arcallid);	
		
		if( !socket_write($this->sock, $request, strlen($request)) ) {
			echo "SendResponse(): Socket error.Cannot send.(function: socket_write)";
		}	
		$this->CleanupFiles($filepath,$filename);		
	}	
	
	function CleanupFiles($filepath,$filename)
	{
		// delete callid file		
		if (is_writable($filepath."/calls/".$filename)) {
			if (is_writable($filepath."/calls/".$filename)) {
				unlink($filepath."/calls/".$filename);
			} else {
				echo "The file '".$filename."' doesn't writable for delete.";
			}
		} else {
			echo "The file '".$filename."' doesn't exist for delete.";
		}

		$callid = substr($filename,0,strlen($filename)-4);
		// echo "Delete callid file:".$filename." with callid:".$callid."\n";
		
		// cleanup id-s file
		$filename = $filepath."/callids.txt";
		$filename2 = $filepath."/callids2.txt";
		$filename3 = $filepath."/callids3.txt";

		if ( !$this->CheckFileContentAndClean($filename, $callid) ) {
			if ( !$this->CheckFileContentAndClean($filename2, $callid) ) {
				if ( !$this->CheckFileContentAndClean($filename3, $callid) ) {
					echo "Call ID not found:".$callid;
				}
			}
		}	
	}

	function CheckFileContentAndClean($file,$callid)
	{
		if(filesize($file) > 0) {
			if (is_writable($file)) {
				$handle = NULL;
				if (!$handle = fopen($file, 'r+')) {
				 	echo "Cannot open file ".$file."\n";
				 	//exit;
				}
				$content = fread($handle, filesize($file));
				$content = trim($content);
				//echo "File content:".$content."\n";
				//echo "Call ID:".$callid."\n";
				if($content == $callid) {
					// clean content
					//fwrite($handle,"");
					ftruncate($handle, 0);
					//echo "Content deleted.\n";
					fclose($handle);

					return true;
				}
		
				if($handle)
					fclose($handle);
		
			} else {
				echo "The file ".$file." is not writable.\n";
			}
		}

		return false;
	}
	
	function MultiArraySearch($search, $arr)
	{
		foreach($arr as $key => $value ) {
			if($key == $search) {
				return true;
			}
		}
		return false;	
	}

	function Transfer($from,$to,$transfer_to)
	{
		if(empty($from)) {
			echo "Parameter 'from' is empty !";
		}
		if(empty($to)) {
			echo "Parameter 'to' is empty !";
		}
		if(empty($transfer_to)) {
			echo "Parameter 'transfer_to' is empty !";
		}
		
		echo "Date: ".date("F j, Y, g:i a")."\n\n";		
	
		$this->CreateCall($from,$to,null,null,$transfer_to,null,true);
	}	
	
	function GenerateCallID()
	{
		 mt_srand(time());

		 $Part1 = ltrim( mt_rand(1, 99999), '-');
		 $Part2 = ltrim( mt_rand(1, 99999), '-');
		 $Part3 = ltrim( mt_rand(1, 99999), '-');
		 $Part4 = ltrim( mt_rand(1, 9999), '-');

		 return $Part1.$Part2.$Part3.$Part4;	
	}
	
	function CreateCall($from, $to, $from2, $to2, $transfer_to, $play_filename, $is_wait_event)
	{
		$call_id = $this->GenerateCallID();
		$this->arrTransferIDs[$call_id] = $transfer_to;
		$this->arrSubscrExtension[$call_id] = $to;

		$arr = array($call_id, $from, $to);
		$method = "Services.CallProcessingService.createcall";	
		$request = xmlrpc_encode_request($method,$arr);	
		echo $request = $request."\r\n\r\n";	
		
		if( !socket_write($this->sock, $request, strlen($request)) ) {
			echo "CreateCall(): Socket error.Cannot send.(function: socket_write)";
		}	
	}

	function TransferCall($id, $transfer_to)
	{
		$arr = array(trim($id), trim($transfer_to));
		$method = "Services.CallProcessingService.transfercall";	
	
		$request = xmlrpc_encode_request($method,$arr);	
		echo $request = $request."\r\n\r\n";		

		if( !socket_write($this->sock, $request, strlen($request)) ) {
			echo "TransferCall(): Socket error.Cannot send.(function: socket_write)";
		}
	}
	
	function GetAllListenExtensions($filepath)
	{
		$filearr = array();
		$arrExtensions = array();
		$i = 0;
		
		if ($handle = opendir($filepath."/quadro_extensions/")) {
			 while (false !== ($file = readdir($handle))) {
				 
				 if ( is_file($filepath."/quadro_extensions/".$file) ) {
					 //echo "ext file: ".$file."\n";
					 $filearr[$i] = $file;
					 $i++;
				 }
			 }
			 closedir($handle);
		}
	
		//echo "Available ext file count=".$i."\n";
			
		foreach($filearr as $key => $value) {
			
			$filename = $filearr[$key];	
			
			$file = $filepath."/quadro_extensions/".$filename;
			//echo "User ext file name: ".$file."\n";
			$handle = fopen($file, "r"); // $filename: username.txt
			if ( filesize($file) == 0 ) {
				continue;
			}	
			$content = fread($handle, filesize($file));
			fclose($handle);
			
			array_push($arrExtensions, $content);
		}
		
		return $arrExtensions;
	}
	
	function CleanupDir($dir_name)
	{
		$dir_name = "/".$dir_name."/";
		if ($handle = opendir($this->gl_filepath.$dir_name)) {
			 while (false !== ($file = readdir($handle))) {
				 
				 if ( is_file($this->gl_filepath.$dir_name.$file) ) {
					 echo "Delete file: ".$file."\n";
					 unlink($this->gl_filepath.$dir_name.$file);
				 }
			 }
			 closedir($handle);
		}			
	}

	function TruncateFile($file)
	{
		// $file - must contain full path to file
		if (!$handle = fopen($file, 'w+')) {
		 	echo "Cannot open file ".$file."\n";
		 	exit(0);
		}
		fclose($handle);
	}

	function ResetAll()
	{
		$this->CleanupDir("calls");
		$this->CleanupDir("out_calls");
		$this->TruncateFile($this->gl_filepath."/callids.txt");
		$this->TruncateFile($this->gl_filepath."/callids2.txt");
		$this->TruncateFile($this->gl_filepath."/callids3.txt");	
	}				
}
?>